Imports MSXML2

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents txtOrders As System.Windows.Forms.TextBox

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.txtOrders = New System.Windows.Forms.TextBox
        Me.SuspendLayout()
        '
        'txtOrders
        '
        Me.txtOrders.Dock = System.Windows.Forms.DockStyle.Fill
        Me.txtOrders.Location = New System.Drawing.Point(0, 0)
        Me.txtOrders.Multiline = True
        Me.txtOrders.Name = "txtOrders"
        Me.txtOrders.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.txtOrders.Size = New System.Drawing.Size(184, 317)
        Me.txtOrders.TabIndex = 1
        Me.txtOrders.Text = ""
        Me.txtOrders.TextAlign = System.Windows.Forms.HorizontalAlignment.Right
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(184, 317)
        Me.Controls.Add(Me.txtOrders)
        Me.Name = "Form1"
        Me.Text = "SAXOrders"
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' The SAX XML Reader.
    Private m_SaxReader As New SAXXMLReader()

    ' The SAX reader's error handler.
    Private WithEvents m_ErrorHandler As New OrderErrorHandler()

    ' The SAX reader's content handler.
    Private WithEvents m_ContentHandler As New OrderContentHandler()

    ' The grand total of all orders.
    Private m_GrandTotal As Double

    ' The error handler is reporting an error.
    Private Sub m_ErrorHandler_OrderError(ByVal oLocator As MSXML2.IVBSAXLocator, ByRef strErrorMessage As String, ByVal nErrorCode As Integer) Handles m_ErrorHandler.OrderError
        MsgBox("Error parsing XML document." & _
            vbCrLf & "Line: " & oLocator.lineNumber & _
            vbCrLf & "Column: " & oLocator.columnNumber, _
            MsgBoxStyle.Information Or MsgBoxStyle.OKOnly, _
            "Parse Error")
    End Sub

    ' Record an order total.
    Private Sub m_ContentHandler_OrderTotaled(ByVal order_total As Double) Handles m_ContentHandler.OrderTotaled
        ' Add the order total to the output text.
        txtOrders.Text &= Format(order_total, "$#,##0.00") & vbCrLf

        ' Add the order total to the grand total.
        m_GrandTotal = m_GrandTotal + order_total
    End Sub

    ' Get the XML file's name.
    Private Function XmlFileName() As String
        Dim file_name As String = Application.ExecutablePath
        file_name = file_name.Substring(0, file_name.LastIndexOf("\"))

        Return file_name & "\SAXOrders.xml"
    End Function

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Set the SAX XML Reader's content handler.
        m_SaxReader.contentHandler = m_ContentHandler

        ' Set the SAX XML Reader's error handler.
        m_SaxReader.errorHandler = m_ErrorHandler

        ' Clear out any previous results.
        m_GrandTotal = 0

        ' Make the SAX reader parse the document.
        Try
            m_SaxReader.parseURL(XmlFileName())
        Catch exc As Exception
            MsgBox(exc.Message)
        End Try

        ' Display the grand total.
        txtOrders.Text &= "--------------------" & vbCrLf & _
            "Grand Total: " & Format(m_GrandTotal, "$#,##0.00")
        txtOrders.Focus()
        txtOrders.Select(txtOrders.Text.Length, 0)
        Me.Show()
        txtOrders.ScrollToCaret()
    End Sub
End Class
