Imports System.IO
Imports System.Xml

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents btnDeserialize As System.Windows.Forms.Button
    Friend WithEvents btnSerialize As System.Windows.Forms.Button
    Friend WithEvents picImage As System.Windows.Forms.PictureBox

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.Container

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents txtResults As System.Windows.Forms.TextBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Form1))
        Me.btnSerialize = New System.Windows.Forms.Button
        Me.picImage = New System.Windows.Forms.PictureBox
        Me.btnDeserialize = New System.Windows.Forms.Button
        Me.txtResults = New System.Windows.Forms.TextBox
        Me.SuspendLayout()
        '
        'btnSerialize
        '
        Me.btnSerialize.Location = New System.Drawing.Point(312, 8)
        Me.btnSerialize.Name = "btnSerialize"
        Me.btnSerialize.Size = New System.Drawing.Size(72, 24)
        Me.btnSerialize.TabIndex = 3
        Me.btnSerialize.Text = "Serialize"
        '
        'picImage
        '
        Me.picImage.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.picImage.Image = CType(resources.GetObject("picImage.Image"), System.Drawing.Image)
        Me.picImage.Location = New System.Drawing.Point(0, 0)
        Me.picImage.Name = "picImage"
        Me.picImage.Size = New System.Drawing.Size(304, 273)
        Me.picImage.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize
        Me.picImage.TabIndex = 0
        Me.picImage.TabStop = False
        '
        'btnDeserialize
        '
        Me.btnDeserialize.Location = New System.Drawing.Point(312, 48)
        Me.btnDeserialize.Name = "btnDeserialize"
        Me.btnDeserialize.Size = New System.Drawing.Size(72, 24)
        Me.btnDeserialize.TabIndex = 3
        Me.btnDeserialize.Text = "Deserialize"
        '
        'txtResults
        '
        Me.txtResults.Location = New System.Drawing.Point(0, 280)
        Me.txtResults.Multiline = True
        Me.txtResults.Name = "txtResults"
        Me.txtResults.ReadOnly = True
        Me.txtResults.ScrollBars = System.Windows.Forms.ScrollBars.Vertical
        Me.txtResults.Size = New System.Drawing.Size(264, 80)
        Me.txtResults.TabIndex = 4
        Me.txtResults.Text = ""
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(392, 485)
        Me.Controls.Add(Me.txtResults)
        Me.Controls.Add(Me.btnSerialize)
        Me.Controls.Add(Me.btnDeserialize)
        Me.Controls.Add(Me.picImage)
        Me.Name = "Form1"
        Me.Text = "SerializeImage"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub btnSerialize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSerialize.Click
        Cursor = Cursors.WaitCursor
        Refresh()

        ' Make the XmlTextWriter.
        Dim xml_text_writer As New XmlTextWriter(XmlFileName(), System.Text.Encoding.UTF8)
        xml_text_writer.Formatting = Formatting.Indented
        xml_text_writer.WriteStartDocument(True)

        ' Make a Picture element.
        xml_text_writer.WriteStartElement("Picture")
        xml_text_writer.WriteAttributeString("Encoding", "Base64")

        ' Copy the picture into a memory stream.
        Dim memory_stream As New MemoryStream
        picImage.Image.Save(memory_stream, picImage.Image.RawFormat)

        ' Copy the memory stream into a byte array.
        Dim bytes(memory_stream.Length - 1) As Byte
        bytes = memory_stream.ToArray()

        ' Save the array's length as an attribute.
        xml_text_writer.WriteAttributeString("NumBytes", bytes.Length)

        ' Write the byte data into the XML file.
        xml_text_writer.WriteBase64(bytes, 0, bytes.Length)

        ' End the Picture element.
        xml_text_writer.WriteEndElement()

        ' End the XML document.
        xml_text_writer.WriteEndDocument()
        xml_text_writer.Close()

        ' Clear the image.
        picImage.Image = Nothing

        ' Display the XML file.
        Dim stream_reader As New IO.StreamReader(XmlFileName())
        txtResults.Text = stream_reader.ReadToEnd()
        txtResults.Select(0, 0)
        stream_reader.Close()

        Cursor = Cursors.Default
    End Sub

    Private Sub btnDeserialize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDeserialize.Click
        Cursor = Cursors.WaitCursor
        Refresh()

        ' Create the XmlTextReader.
        Dim xml_text_reader As New XmlTextReader(XmlFileName())

        ' Find the Picture element.
        Do While xml_text_reader.Read()
            ' See if this is the Picture element.
            If xml_text_reader.Name = "Picture" Then
                ' Allocate space for the data.
                Dim num_bytes As Long = xml_text_reader.GetAttribute("NumBytes")
                Dim bytes(num_bytes - 1) As Byte

                ' Read the data.
                xml_text_reader.ReadBase64(bytes, 0, num_bytes)

                ' Allocate a MemoryStream filled with the bytes.
                Dim memory_stream As New MemoryStream(bytes)

                ' Load the picture from the memory stream.
                picImage.Image = Image.FromStream(memory_stream)

                txtResults.Text = ""
                Exit Do
            End If
        Loop
        xml_text_reader.Close()

        Cursor = Cursors.Default
    End Sub

    ' Get the XML file's name.
    Private Function XmlFileName() As String
        Dim file_name As String = Application.ExecutablePath
        file_name = file_name.Substring(0, file_name.LastIndexOf("\"))

        Return file_name & "\SerializeImageText.xml"
    End Function

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        Dim hgt As Integer = ClientSize.Height - txtResults.Top
        If hgt < 10 Then hgt = 10
        txtResults.SetBounds(0, txtResults.Top, ClientSize.Width, hgt)
    End Sub
End Class
